function _1(md){return(
md`# Map-stodon

A quick and dirty graph-viz of mastoverse as of 9/11/2022. Graph derived from 500 status of each instances public timeline.`
)}

function _instance(Inputs,graph){return(
Inputs.select(graph.nodes.map(d=>d.attributes.label).sort(), {label: "Instance name : "})
)}

function _3(html,chart,instance)
{
  const form = html`<form>
  <button name="out" type="button">Zoom Out</button>
  <button name="instance" type="button">Zoom to selected instance</button>
</form>`;
  form.out.onclick = () => chart.zoomOut();
  form.instance.onclick = () => chart.zoomTo(instance);
  return form;
}


function _chart(d3,html,width,height,graph,size,col,x,y,set,$0,fontsize,regions,labels_pos)
{
  const svg = d3.select(
    html`<svg width="100%" height="100%" viewBox="0, 0, ${width}, ${height}">
          <defs>
          <filter id="whiteOutlineEffect" color-interpolation-filters="sRGB">
            <feMorphology in="SourceAlpha" result="MORPH" operator="dilate" radius="2" />
            <feColorMatrix in="MORPH" result="WHITENED" type="matrix" values="-1 0 0 0 1, 0 -1 0 0 1, 0 0 -1 0 1, 0 0 0 1 0"/>
            <feMerge>
              <feMergeNode in="WHITENED"/>
              <feMergeNode in="SourceGraphic"/>
            </feMerge>
          </filter>
          </defs>
        </svg>`);
  
  var zoomed = function(event) {
    g.attr("transform", event.transform);
    if(event.transform.k>2.5){
        labels.style("visibility","visible")
    }else{
        labels.style("visibility","hidden")
    }
    if(event.transform.k>2.5){
        regions_labels.style("visibility","hidden")
    }else{
        regions_labels.style("visibility","visible")
    }
  }

  var zoom = d3.zoom()
        .scaleExtent([0.5, 1000])
        .on("zoom", zoomed)
  
  var zoomH = svg
    .call(zoom);
  
  const g = svg.append("g").attr("id","g-graph");

  const info_labels = g.append("g")
    .attr("id","info-labels")
    .selectAll("text")
    .data([0,0])
    .join("text")
    .text(d=>d)
    .attr("transform", (d,i) => `translate(10 ${i*10})`)

  
  const circle = g.append("g")
    .selectAll("circle")
    .data(graph.nodes)
    .join("circle")
    .attr("r", d=> size(d.attributes["nansi-indegree"]))
    .style("fill", d=> col(d.attributes["nansi-louvain"]))
    .style("stroke",d => d3.color(col(d.attributes["nansi-louvain"])).darker())
    .style("stroke-width", 0)
    .attr("transform", d => `translate(${x(d.attributes.x)} ${y(d.attributes.y)})`)
    .on("click",function(d){
      circle
        .style("stroke-width", 0)
      d3.select(this)
        .style("stroke-width", 2)
        .attr("r", d=> 1.2*size(d.attributes["nansi-indegree"]))
      set($0,this.__data__.attributes.label)
    });

  

    

  const labels = g.append("g")
    .attr("id","nodes-labels")
    .selectAll("text")
    .data(graph.nodes)
    .join("text")
    .attr("class","labels")
    .attr("text-anchor","middle")
    .style("visibility","hidden")
    .style("font-size",d=>fontsize(d.attributes["nansi-indegree"])+"%")
    .text(d=>d.attributes.label.replace("mastodon","").replace("\.social",""))
    .attr("transform", d => `translate(${x(d.attributes.x)} ${y(d.attributes.y)})`)
    

  const regions_labels = g.append("g")
    .attr("id","regions-labels")
    .selectAll("text")
    .data(regions)
    .join("text")
    .text(d=>d.label)
    .attr("class","regions-labels")
    .attr("filter","url(#whiteOutlineEffect)")
    .attr("text-anchor","middle")
    .style("visibility","visible")
    .style("font-family","garamond")
    .style("font-size","150%")
    .style("fill", d=>col(d.col))
    .attr("transform", d => `translate(${x(d.x)} ${y(d.y)})`)
  
  




  var zoomTo = function(instance_name){
    var attr = labels_pos.get(instance_name)[0].attributes
    var move = d3.zoomIdentity.translate(width / 2, height / 2).scale(12).translate(-x(attr.x),-y(attr.y))
    zoomH.transition().duration(2500).call(zoom.transform,move)
  }
  
  return Object.assign(svg.node(), {
    zoomOut: () => g.transition().call(zoom.transform, d3.zoomIdentity),
    zoomTo: zoomTo
  });
  
}


function _timeline(d3,html,public_toots)
{ 
  const toots_list = d3.select(html`
    <div id="toots">
    </div>
    `);
  const toots = toots_list.selectAll("article")
    .data(public_toots)
    .join("article")
    .attr("class","box media")

    
  toots
    .append("div")
    .attr("class","media-left")
    .html(toot => ` 
            <a href="${toot.account.url}">
              <figure class="image is-64x64"><img src="${toot.account.avatar_static}" alt="Avatar"></figure>
            </a> `)

  toots
    .append("div")
    .attr("class","media-content")
    .html(toot => ` 
             <a href=${toot.account.url}>
                  <div class="content">
                    <p>
                      <strong>${toot.account.display_name}</strong>
                      <small>@${toot.account.acct}</small>
                    </p>
                  </div>
              </a>
          <p>${toot.content}</p>
          <small><a href=${toot.uri}</a>${toot.created_at}</small>
        `)
  
  
  return toots_list.node()
}


function _regions(){return(
[{label:"French",x:-2500,y: 300,col:1},{label:"Deutch",x:-2300,y: -800,col:6},{label:"Japan",x:-700,y:-500,col:9},{label:"Science",x:-1600,y:500,col:0}]
)}

function _public_toots(d3,instance){return(
d3.json("https://"+instance+"/api/v1/timelines/public")
)}

function _labels_pos(d3,graph){return(
d3.group(graph.nodes, n => n.attributes.label)
)}

function _9(graph){return(
graph.nodes.map(d=>d.attributes.label).sort()
)}

function _graph(FileAttachment){return(
FileAttachment("graphF.json").json()
)}

function _margin(){return(
10
)}

function _x(d3,margin,width){return(
d3.scaleLinear()
    .domain([-2800,-400])
    .range([margin,width-margin])
)}

function _y(d3,height,margin){return(
d3.scaleLinear()
    .domain([-1050,1050])
    .range([height-margin,margin])
)}

function _col(d3){return(
d3.scaleOrdinal().range(d3.schemeCategory10)
)}

function _size(d3){return(
d3.scaleSqrt().domain([0,150]).range([1,10])
)}

function _fontsize(d3){return(
d3.scaleSqrt().domain([1,150]).range([8,30])
)}

function _height(width){return(
width * 0.6
)}

function _d3(require){return(
require("d3@6")
)}

function _19(html){return(
html`
<style>
  text {
    font-family: verdana;
    font-size: 7pt;
    cursor: pointer;
  }
circle {
    cursor: pointer;
  }
.toot_frame {
  width: 500px;
  height: 300px;
}

.content figure {
  margin: 0px;
  text-align: left;
}

.attachement img {
  max-width: 100%;
}

p {
  /* https://css-tricks.com/snippets/css/prevent-long-urls-from-breaking-out-of-container/ */
  overflow-wrap: break-word;
  word-wrap: break-word;
  -ms-word-break: break-all;
  word-break: break-all;
  word-break: break-word;
  -ms-hyphens: auto;
  -moz-hyphens: auto;
  -webkit-hyphens: auto;
  hyphens: auto;
}

</style>
`
)}

function _20(html){return(
html`<link type="text/css" href="https://cdnjs.cloudflare.com/ajax/libs/bulma/0.7.1/css/bulma.min.css" rel="stylesheet" />`
)}

function _set(Event){return(
function set(input, value) {
  input.value = value;
  input.dispatchEvent(new Event("input", {bubbles: true}));
}
)}

export default function define(runtime, observer) {
  const main = runtime.module();
  function toString() { return this.url; }
  const fileAttachments = new Map([
    ["graphF.json", {url: new URL("./files/4f63d6c0d71ffdef30dc7a67ea34081d45bcb1b936a36ce35b51fe7f31cabb27df00e3be5d775f011d9da3fcb1d57acdaeaeab380800b71a11674ed51c6da164.json", import.meta.url), mimeType: "application/json", toString}]
  ]);
  main.builtin("FileAttachment", runtime.fileAttachments(name => fileAttachments.get(name)));
  main.variable(observer()).define(["md"], _1);
  main.variable(observer("viewof instance")).define("viewof instance", ["Inputs","graph"], _instance);
  main.variable(observer("instance")).define("instance", ["Generators", "viewof instance"], (G, _) => G.input(_));
  main.variable(observer()).define(["html","chart","instance"], _3);
  main.variable(observer("chart")).define("chart", ["d3","html","width","height","graph","size","col","x","y","set","viewof instance","fontsize","regions","labels_pos"], _chart);
  main.variable(observer("timeline")).define("timeline", ["d3","html","public_toots"], _timeline);
  main.variable(observer("regions")).define("regions", _regions);
  main.variable(observer("public_toots")).define("public_toots", ["d3","instance"], _public_toots);
  main.variable(observer("labels_pos")).define("labels_pos", ["d3","graph"], _labels_pos);
  main.variable(observer()).define(["graph"], _9);
  main.variable(observer("graph")).define("graph", ["FileAttachment"], _graph);
  main.variable(observer("margin")).define("margin", _margin);
  main.variable(observer("x")).define("x", ["d3","margin","width"], _x);
  main.variable(observer("y")).define("y", ["d3","height","margin"], _y);
  main.variable(observer("col")).define("col", ["d3"], _col);
  main.variable(observer("size")).define("size", ["d3"], _size);
  main.variable(observer("fontsize")).define("fontsize", ["d3"], _fontsize);
  main.variable(observer("height")).define("height", ["width"], _height);
  main.variable(observer("d3")).define("d3", ["require"], _d3);
  main.variable(observer()).define(["html"], _19);
  main.variable(observer()).define(["html"], _20);
  main.variable(observer("set")).define("set", ["Event"], _set);
  return main;
}
